#include <windows.h>

#define MAX_MESSAGE_LEN	128
#define MAX_LOOP		5
#define MAX_THREAD		3

CRITICAL_SECTION g_ScreenCS;
CRITICAL_SECTION g_StatsCS;

HANDLE g_hStdOut;
DWORD g_dwCharCount = 0;
DWORD g_dwLineCount = 0;

DWORD WINAPI MyThread(LPVOID lpVoid)
{
	CHAR szMessage[MAX_MESSAGE_LEN];
	DWORD dwThreadId = GetCurrentThreadId();
	DWORD dwWritten = 0;
	int i, j;

	wsprintf(szMessage, "Ciao dal thread %u\n", dwThreadId);
	for(i = 0; i < MAX_LOOP; i++)
	{
		for(j = 0; j < MAX_LOOP; j++)
		{
			EnterCriticalSection(&g_ScreenCS);
			WriteFile(g_hStdOut, szMessage, strlen(szMessage), &dwWritten, NULL);
			LeaveCriticalSection(&g_ScreenCS);
			
			EnterCriticalSection(&g_StatsCS);
			++g_dwLineCount;
			g_dwCharCount += dwWritten;
			LeaveCriticalSection(&g_StatsCS);
		}
	}
	return 0;
}

int main()
{
	HANDLE hThread[MAX_THREAD];
	CHAR szMessage[MAX_MESSAGE_LEN];
	DWORD dwWritten = 0;
	int i;

	g_hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	InitializeCriticalSection(&g_ScreenCS);
	InitializeCriticalSection(&g_StatsCS);

	for(i = 0; i < MAX_THREAD; ++i)
		hThread[i] = CreateThread(NULL, 0, MyThread, NULL, 0, NULL);

	WaitForMultipleObjects(MAX_THREAD, hThread, TRUE, INFINITE);

	DeleteCriticalSection(&g_ScreenCS);
	DeleteCriticalSection(&g_StatsCS);

	wsprintf(szMessage, "Scritti %u caratteri su %u linee\n", g_dwCharCount, g_dwLineCount);
	WriteFile(g_hStdOut, szMessage, strlen(szMessage), &dwWritten, NULL);

	return 0;
}