#!/bin/bash

ARGS=2

E_NOTFOUND=1
E_BADARG=2
E_BADFILE=3

if [ $ARGS -ne $# ]
then
	echo "Usage: $(basename $0) word filename"
	exit $E_BADARG
fi

if [ ! -f "$2" ]
then
	echo "File \"$2\" does not exist."
	exit $E_BADFILE
fi

word=$1
w_list=$(cat "$2")
count=0

for w in $w_list
do
	if [ "$word" == "$w" ]
	then
		((count++)) #oppure let "count++"
	fi
done

if [ $count -eq 0 ]
then
	echo "Word \"$word\" not found in file \"$2\""
	exit $E_NOTFOUND
fi

echo "Found $count matches of word \"$word\" in file \"$2\""

exit 0
